-- module_src.lua: Steelport Racing Club [nclok1405]

SRC_FAKE_MULTIPLAYER = true

-- Game IDs
SRC_SRTT = 1
SRC_SRIV = 2

-- Race Data
SRC_RACES = {
	{
		-- Displayed Race Name
		name = "JIMMY'S SNAKES",
		-- Player spawn location
		spawn_grid = {
			[LOCAL_PLAYER]  = {x = -1071.60, y = 18.50, z = -904.96},
			[REMOTE_PLAYER] = {x = -1087.00, y = 18.46, z = -897.01},
		},
		-- Starting Grid
		starting_grid = {
			[LOCAL_PLAYER]  = {x = -1080.24, y = 18.50, z = -930.59, dist = 3},
			[REMOTE_PLAYER] = {x = -1086.55, y = 18.59, z = -929.41, dist = 3},
		},
		-- Checkpoints
		checkpoints = {
			{x = -1207.52, y = 18.64, z = -1065.72, dist = 10},
			{x = -1455.49, y = 18.64, z = -1068.64, dist = 15},
			{x = -1657.95, y = 11.75, z = -1040.83, dist = 20},
			{x = -1638.35, y =  7.64, z =  -760.01, dist = 15},
			{x = -1527.95, y =  8.15, z =  -722.46, dist = 15},
			{x = -1759.28, y =  4.61, z =  -555.43, dist = 25},
			{x = -1353.58, y = 25.68, z =  -543.18, dist = 10},
			{x = -1228.92, y = 32.64, z =  -598.04, dist = 10},
			{x = -1004.69, y = 26.95, z =    32.65, dist = 10},
			{x = -1280.02, y =  2.82, z =   257.07, dist = 20},
		},
		-- Time Limit {Gold, Silver, Bronze}
		time = {120, 20, 40},
		-- Police notoriety
		police_notoriety_min = 0,
		police_notoriety_max = 0,
		-- Roadblocks
		roadblocks = false,
		-- Density
		traffic_density = 1,
		pedestrian_density = 1,
		warp_on_exit = false,
	},

	{
		name = "JUMP TO SUBROUTINE",
		spawn_grid = {
			[LOCAL_PLAYER]  = {x = 1627.19, y = 60.52, z = -1209.56},
			[REMOTE_PLAYER] = {x = 1630.36, y = 60.59, z = -1205.39},
		},
		starting_grid = {
			[LOCAL_PLAYER]  = {x = 1574.00, y = 60.51, z = -1157.13, dist = 3},
			[REMOTE_PLAYER] = {x = 1579.03, y = 60.56, z = -1152.82, dist = 3},
		},
		checkpoints = {
			{x = 1472.03, y = 48.45, z = -902.39, dist = 10},
			{x = 1282.03, y = 30.57, z = -816.59, dist = 10},
			{x = 1141.56, y = 25.69, z = -842.65, dist = 10},
			{x = 1108.91, y = 26.26, z = -906.93, dist = 10},
			{x = 1233.56, y = 32.50, z = -887.13, dist = 10},
			{x = 1383.29, y = 28.27, z = -738.29, dist = 10},
			{x = 1579.18, y = 24.88, z = -698.09, dist = 10},
			{x = 1597.11, y = 21.92, z = -862.60, dist = 10},
			{x = 1745.61, y =  8.51, z =  -71.22, dist = 10},
			{x = 1505.16, y = 25.52, z = -102.67, dist = 10},
			{x = 1493.03, y = 27.59, z = -256.75, dist = 10},
		},
		time = {85, 10, 10},
		police_notoriety_min = 0,
		police_notoriety_max = 0,
		roadblocks = false,
		traffic_density = 0.5,
		pedestrian_density = 0.3,
		warp_on_exit = false,
	},

	{
		name = "GENKI DRIVING SCHOOL",
		spawn_grid = {
			[LOCAL_PLAYER]  = {x = -1803.64, y = -299.19, z = -1126.53},
			[REMOTE_PLAYER] = {x = -1809.97, y = -299.19, z = -1127.02},
		},
		starting_grid = {
			[LOCAL_PLAYER]  = {x = -1811.94, y = -299.19, z = -1133.27, dist = 1.5},
			[REMOTE_PLAYER] = {x = -1812.19, y = -299.19, z = -1131.03, dist = 1.5},
		},
		checkpoints = {
			{x = -1809.01, y = -299.19, z = -1143.52, dist = 2},
			{x = -1816.30, y = -299.19, z = -1158.22, dist = 2},
			{x = -1803.25, y = -299.19, z = -1163.52, dist = 2},
			{x = -1808.33, y = -299.19, z = -1178.82, dist = 2},
			{x = -1813.87, y = -299.19, z = -1189.00, dist = 2},
			{x = -1811.35, y = -299.19, z = -1204.47, dist = 2},
			{x = -1816.96, y = -299.19, z = -1215.08, dist = 2},
			{x = -1808.49, y = -299.19, z = -1229.40, dist = 2},
			{x = -1808.38, y = -299.19, z = -1287.07, dist = 2},
			{x = -1808.47, y = -299.19, z = -1349.78, dist = 2},
		},
		time = {55, 10, 10},
		police_notoriety_min = 0,
		police_notoriety_max = 0,
		roadblocks = false,
		traffic_density = 0,
		pedestrian_density = 0,
		warp_on_exit = true,
	},

	-- Coordinate Viewer Tool
	{
		name = "COORDINATE VIEWER",
		is_coordinate_viewer = true,
	},

	-- Vanilla Replay. Must be next to the last entry of the list!
	{
		name = "MISSION REPLAY",
		is_replay = true,
	},
	-- Exit. Must be the last entry of the list!
	{
		name = "EXIT",
		is_exit = true,
	},
}

-- Previous Buttons
SRC_PREV_BUTTONS = {
	"CBA_VDC_PREV_RADIO",
	"CBA_OFC_TAUNT_TWO",
	"CBA_GAC_WEAPON_SELECT_1",
	"CBA_OFC_CROUCH",
}
-- Next Buttons
SRC_NEXT_BUTTONS = {
	"CBA_VDC_NEXT_RADIO",
	"CBA_OFC_TAUNT_THREE",
	"CBA_GAC_WEAPON_SELECT_2",
	"CBA_OFC_PICKUP_RELOAD",
}

-- AI
SRC_AI_SRTT = "BBP 001"
SRC_AI_SRIV = "ps_ambush02_wave01_npc<001>"
SRC_AI_HUMAN_GROUP = { [SRC_SRTT] = "GRP BBP Guards", [SRC_SRIV] = "ps_ambush02_grp" }
SRC_AI_VEHICLE_GROUP = { [SRC_SRTT] = "GRP Outside Cover Vehicles", [SRC_SRIV] = "ps_ambush02_grp" }
SRC_AI_HUMAN = { [SRC_SRTT] = SRC_AI_SRTT, [SRC_SRIV] = SRC_AI_SRIV }
SRC_AI_VEHICLE = { [SRC_SRTT] = "Luch Cover Veh 001", [SRC_SRIV] = "ps_ambush02_wave01_veh" }

-- Exit Warp Location
SRC_EXIT_WARP = {
	--[LOCAL_PLAYER] =  {x = -254.80, y = 12.35, z = 348.56},
	--[REMOTE_PLAYER] = {x = -247.06, y = 12.41, z = 359.36},
	[LOCAL_PLAYER] =  {x = 2093.62, y = 4.40, z = -234.42},
	[REMOTE_PLAYER] = {x = 2081.54, y = 4.24, z = -264.19},
}

-- Marker during Freeroam
-- Broken Shillelagh: mm_p_06
SRC_FREEROAM_MARKER_MISSION = { [SRC_SRTT] = "mm_k_01", [SRC_SRIV] = "" }

SRC_FREEROAM_MARKER_LOCATION = {
	-- Broken Shillelagh: x = 278.10, y = 12.19, z = 348.73
	[SRC_SRTT] = {x = 2129.77, y = 4.00, z = -258.18},
	[SRC_SRIV] = {x = 2129.77, y = 4.00, z = -258.18},
}

-- On screen message tags
SRC_MSG_TAGS = {
	[SRC_SRTT] = {
		objective_steal_a_car = "M03_OBJ_STEAL_A_CAR",
		race_start_countdown = "ACT_TORCH_OBJECTIVE_01",
		medal_gold   = "DIVERSION_SURVIVAL_GOAL_NAME_GOLD",
		medal_silver = "DIVERSION_SURVIVAL_GOAL_NAME_SILVER",
		medal_bronze = "DIVERSION_SURVIVAL_GOAL_NAME_BRONZE",
	},
	[SRC_SRIV] = {
		objective_steal_a_car = "M19_OBJ_GET_CAR",
		race_start_countdown = "QUEST_OQ_DAVID1_OBJ2GSI",
		medal_gold   = "TIERS_CMP_JUST_GOLD",
		medal_silver = "TIERS_CMP_JUST_SILVER",
		medal_bronze = "TIERS_CMP_JUST_BRONZE",
	},
}

-- Medals
SRC_MEDAL_GOLD = 1
SRC_MEDAL_SILVER = 2
SRC_MEDAL_BRONZE = 3
SRC_MEDAL_FAIL = 4

-- Race Sound
SRC_AUDIO_FAIL   = { [SRC_SRTT] = "WEP_GENKI_UNETHICAL", [SRC_SRIV] = "WARDEN_QTE_FAIL" }
SRC_AUDIO_GOLD   = { [SRC_SRTT] = "UI_HUD_CHOP_SHOP_COMPLETE", [SRC_SRIV] = "UI_ACTIVITY_COMPLETE_GOLD" }
SRC_AUDIO_SILVER = { [SRC_SRTT] = "UI_HUD_CHOP_SHOP_COMPLETE", [SRC_SRIV] = "UI_ACTIVITY_COMPLETE_SILVER" }
SRC_AUDIO_BRONZE = { [SRC_SRTT] = "UI_HUD_CHOP_SHOP_COMPLETE", [SRC_SRIV] = "UI_ACTIVITY_COMPLETE_BRONZE" }
SRC_AUDIO_CHECKPOINT_PASSED = { [SRC_SRTT] = "Trail_Blazing_Angel_Checkpoint", [SRC_SRIV] = "tb_checkpoint_reached" }

SRC_HUD_PLAYER_INDEX = { [LOCAL_PLAYER] = 1, [REMOTE_PLAYER] = 2 }

-- Mini Waypoint Vehicles
SRC_MINI_WAYPOINT_VEHICLES = {
	[LOCAL_PLAYER] = "Script_Vehicle_Gat<001>", [REMOTE_PLAYER] = "Script_Vehicle_VTOL<001>"
}
-- HACK: Y offset for each mini waypoint vehicle
SRC_MINI_WAYPOINT_Y_OFFSET = { ["Script_Vehicle_Gat<001>"] = -3, ["Script_Vehicle_VTOL<001>"] = -2.5 }

-- DX Waypoint Groups
SRC_DX_WAYPOINT_GROUP = { [SRC_SRTT] = "GRP BDP Guards", [SRC_SRIV] = "ps_ambush01_grp" }
-- DX Waypoint Humans
SRC_DX_WAYPOINT_HUMANS = {
	[SRC_SRTT] = { [LOCAL_PLAYER] = "BDP 001", [REMOTE_PLAYER] = "BDP 002" },
	[SRC_SRIV] = { [LOCAL_PLAYER] = "ps_ambush01_wave01_npc<001>", [REMOTE_PLAYER] = "ps_ambush01_wave01_npc<002>" },
}

-- State IDs
SRC_STATE_EXIT = 0
SRC_STATE_MINI_FREEROAM = 1
SRC_STATE_DX_FREEROAM = 2
SRC_STATE_FIND_CAR = 3
SRC_STATE_GOTO_STARTING_GRID = 4
SRC_STATE_RACE = 5
SRC_STATE_WIN = 6
SRC_STATE_OUT_OF_TIME = 7
SRC_STATE_FAIL = 8
SRC_STATE_MINI_COORDINATE_VIEWER = 9
SRC_STATE_DX_COORDINATE_VIEWER = 10

-- NOTE: Unlike normal missions these global variables are never reset automatically

Src_mission_name = ""	-- Mission name ("" == Mini)
Src_fail_reason = ""
Src_vanilla_replay = false	-- true on vanilla mission replay

Src_state = SRC_STATE_MINI_FREEROAM	-- Current State

Src_players = {}	-- Player list, set after freeroam (won't be changed if a new player joins mid-race)

Src_last_message_handle = {}	-- Message Handles

Src_race_id = 1	-- Selected race ID

Src_abort_timer = 0	-- Manual Abort Timer (counts down from 2 sec after pushing Taunt or Grenade)

Src_freeroam_marker_active = false	-- Freeroam Marker is visible
Src_freeroam_prompt_active = false	-- Freeroam Prompt is active
Src_freeroam_trigger_hit = false	-- E key pushed on Freeroam Prompt

Src_combo_handles = {}	-- Combo HUD handles

Src_warp_on_exit = false	-- Warp on exit

Src_ai_enabled = false	-- AI Enabled
Src_ai_thread_handle = -1	-- AI Thread

-- Main Thread of Steelport Racing Club
-- Run the Mini editon by `thread_new("src_main_thread")` from sr3_city_main()
function src_main_thread(mission_name, checkpoint, is_restart)
	-- Set edition
	if mission_name == nil then
		Src_mission_name = ""
	else
		Src_mission_name = mission_name
	end
	if checkpoint == nil then
		checkpoint = MISSION_START_CHECKPOINT
	end
	if is_restart == nil then
		is_restart = false
	end

	if src_sriv() and src_mini() then
		-- I initially wanted to use homies as waypoints, but the game ignores marker_add and waypoint_add for them :(
		-- So now I have to use Plan B: Add markers and waypoints to "E3 Spawns" vehicles, which are SRTT only.
		-- Hopefully Sperasoft didn't remove the E3 Spawns in SRTT Remastered...
		
		-- I also have Plan C: Avatar Rampage Mini-like approach.
		-- Start a mission that starts from "Go to Place A", erase triggers of "Place A", and take over the mission flow from there.
		return
	end

	-- Wait until the loading screen goes away
	if is_restart then
		mission_start_fade_in()
	end
	fade_in_block()

	if src_mini() then
		-- Wait until the player completes the prologue
		while (not mission_is_complete("m03")) or mission_is_active() or (not cutscene_play_check_done()) do
			thread_yield()
		end
	end

	Src_warp_on_exit = false

	if src_mini() then
		Src_state = SRC_STATE_MINI_FREEROAM
	elseif src_dx() then
		-- By default, start from Race Selector
		Src_state = SRC_STATE_DX_FREEROAM
		
		-- Handle mission checkpoint
		for id, race in pairs(SRC_RACES) do
			if race.name == checkpoint then
				Src_race_id = id
				Src_state = SRC_STATE_FIND_CAR
				break
			end
		end
	end

	-- Run a state
	while Src_state ~= SRC_STATE_EXIT do
		if Src_state == SRC_STATE_MINI_FREEROAM then
			Src_state = src_state_mini_freeroam()
		elseif Src_state == SRC_STATE_DX_FREEROAM then
			Src_state = src_state_dx_freeroam()
		elseif Src_state == SRC_STATE_FIND_CAR then
			Src_state = src_state_find_car()
		elseif Src_state == SRC_STATE_GOTO_STARTING_GRID then
			Src_state = src_state_goto_starting_grid()
		elseif Src_state == SRC_STATE_RACE then
			Src_state = src_state_race()
		elseif Src_state == SRC_STATE_WIN then
			Src_state = src_state_win()
		elseif Src_state == SRC_STATE_OUT_OF_TIME then
			Src_state = src_state_out_of_time()
		elseif Src_state == SRC_STATE_FAIL then
			Src_state = src_state_fail()
		elseif Src_state == SRC_STATE_MINI_COORDINATE_VIEWER then
			Src_state = src_state_mini_coordinate_viewer()
		elseif Src_state == SRC_STATE_DX_COORDINATE_VIEWER then
			Src_state = src_state_dx_coordinate_viewer()
		end
	end
end

-- Entry point for DX: SRTT
function sui_override_m07_start(checkpoint, is_restart)
	-- Vanilla m07 checkpoints
	local VANILLA_CHECKPOINTS = {"barge", "zimos part 1", "zimos part 2", "angel", "brute", "defense"}
	
	for i, cp in pairs(VANILLA_CHECKPOINTS) do
		if checkpoint == cp then
			-- Vanilla Checkpoint, so let the mission run normally
			Src_vanilla_replay = true
			return false
		end
	end
	
	src_main_thread("m07", checkpoint, is_restart)
	return (not Src_vanilla_replay)
end

-- Cleanup for DX: SRTT
function sui_override_m07_cleanup()
	if Src_vanilla_replay then
		return false
	else
		if Src_warp_on_exit then
			for idx, player in pairs(Src_players) do
				local exit_warp = SRC_EXIT_WARP[player]
				if exit_warp == nil then
					exit_warp = SRC_EXIT_WARP[REMOTE_PLAYER]
				end
				local x = exit_warp.x
				local y = exit_warp.y
				local z = exit_warp.z
				src_teleport_human(player, x, y, z)
			end
		end
		src_cleanup()
		return true
	end
end

-- Success function for DX: SRTT
function sui_override_m07_success()
end

-- Entry point for DX: SRIV
function sui_override_mm_2_1_start(checkpoint, is_restart)
	-- Vanilla mm_2_1 checkpoints
	local VANILLA_CHECKPOINTS = {"mm_2_1_ambush"}

	for i, cp in pairs(VANILLA_CHECKPOINTS) do
		if checkpoint == cp then
			-- Vanilla Checkpoint, so let the mission run normally
			Src_vanilla_replay = true
			return false
		end
	end

	src_main_thread("mm_2_1", checkpoint, is_restart)
	return (not Src_vanilla_replay)
end

-- Cleanup for DX: SRIV
function sui_override_mm_2_1_cleanup()
	if Src_vanilla_replay then
		return false
	else
		if Src_warp_on_exit then
			for idx, player in pairs(Src_players) do
				local exit_warp = SRC_EXIT_WARP[player]
				if exit_warp == nil then
					exit_warp = SRC_EXIT_WARP[REMOTE_PLAYER]
				end
				local x = exit_warp.x
				local y = exit_warp.y
				local z = exit_warp.z
				src_teleport_human(player, x, y, z)
			end
		end
		src_cleanup()
		return true
	end
end

-- Success function for DX: SRIV
function sui_override_mm_2_1_success()
end

-- Get race data
-- id: Race ID (nil for current)
function src_get_race(id)
	if id == nil then
		id = Src_race_id
	end
	return SRC_RACES[id]
end

-- Returns true if all players are dead
function src_is_all_players_dead()
	for idx, player in pairs(Src_players) do
		if not character_is_dead(player) then
			return false
		end
	end
	return true
end

-- Check for abort
function src_check_abort(check_vehicle)
	-- Mission activated
	if src_mini() and (mission_is_active() or (not cutscene_play_check_done())) then
		Src_fail_reason = "DIVERSION_CANCELED"
		return true
	end

	-- All Players Died
	if src_mini() and src_is_all_players_dead() then
		Src_fail_reason = "MISSION_FAILURE_DIED_TEXT"
		return true
	end
	
	-- If during the race
	if check_vehicle then
		-- End the race if all players have no vehicle
		local all_players_have_no_vehicle = true
		for idx, player in pairs(Src_players) do
			if src_is_player_in_valid_car(player) then
				all_players_have_no_vehicle = false
			end
		end
		if all_players_have_no_vehicle then
			Src_fail_reason = "ACT_ESCORT_FAIL_CAR_DESTROYED"
			return true
		end
	end

	-- Manual Cancel
	if src_mini() then
		Src_abort_timer = Src_abort_timer - get_frame_time()
		if Src_abort_timer < 0 then
			Src_abort_timer = 0
		end

		local button_name = "CBA_OFC_ATTACK_SECONDARY"	-- Grenade
		local button_img = "ATTACK_SECONDARY_IMG"
		if player_action_just_pressed(button_name) then
			if Src_abort_timer > 0 then
				Src_fail_reason = "DIVERSION_CANCELED"
				return true
			else
				Src_abort_timer = 2
				src_message("Push {"..button_img.."} again to abort race", 2, LOCAL_PLAYER)
			end
		end
	end

	return false
end

-- Warp back
function src_postrace_warp()
	-- If all players died
	if src_is_all_players_dead() then
		-- Wait until they respawn
		while src_is_all_players_dead() do
			thread_yield()
		end
		-- Wait until the load screen goes away
		fade_in_block()
	end

	mission_start_fade_out()
	fade_out_block()

	local radio_backup = {}

	for idx, player in pairs(Src_players) do
		local myride = get_char_vehicle_name(player)
		
		local exit_warp = SRC_EXIT_WARP[player]
		if exit_warp == nil then
			exit_warp = SRC_EXIT_WARP[REMOTE_PLAYER]
		end
		local x = exit_warp.x
		local y = exit_warp.y
		local z = exit_warp.z
		
		radio_backup[player] = radio_get_station(myride)
		src_teleport_human(player, x, y, z)
	end
	
	mission_start_fade_in()

	for idx, player in pairs(Src_players) do
		local myride = get_char_vehicle_name(player)
		radio_set_station(myride, radio_backup[player])
	end
end

-- STATE: Mini Freeroam
function src_state_mini_freeroam()
	local num_races = #SRC_RACES - 2	-- Don't allow vanilla replay and exit to be selected

	while true do
		thread_yield()
		
		-- If a mission becomes active, wait until it ends
		while mission_is_active() or (not cutscene_play_check_done()) do
			src_clear_freeroam_marker()
			src_clear_freeroam_prompt()
			thread_yield()
		end
		
		local show_selector_message = false
		
		local x = SRC_FREEROAM_MARKER_LOCATION[src_get_game()].x
		local y = SRC_FREEROAM_MARKER_LOCATION[src_get_game()].y
		local z = SRC_FREEROAM_MARKER_LOCATION[src_get_game()].z
		
		local player_is_near_freeroam_marker = src_is_close_enough(LOCAL_PLAYER, x, y, z, 15)
		local player_is_on_freeroam_marker = src_is_close_enough(LOCAL_PLAYER, x, y, z, 10)
		
		if player_is_near_freeroam_marker and (not Src_freeroam_marker_active) then
			marker_add(SRC_FREEROAM_MARKER_MISSION[src_get_game()], "map_other_replaceme", OI_ASSET_USE, OI_FLAGS_FULL, SYNC_LOCAL)
			Src_freeroam_marker_active = true
		elseif (not player_is_near_freeroam_marker) and Src_freeroam_marker_active then
			src_clear_freeroam_marker()
		end
		
		if player_is_on_freeroam_marker and (not Src_freeroam_prompt_active) then
			hud_prompt(LOCAL_PLAYER, "CONTROL_START_GAME", "src_freeroam_triggered")
			Src_freeroam_prompt_active = true
			show_selector_message = true
		elseif (not player_is_on_freeroam_marker) and Src_freeroam_prompt_active then
			src_clear_freeroam_prompt()
		end
		
		-- Previous
		if player_is_on_freeroam_marker and src_is_prev_button_pressed() then
			show_selector_message = true
			Src_race_id = Src_race_id - 1
			if Src_race_id < 1 then
				Src_race_id = num_races
			end
		end
		-- Next
		if player_is_on_freeroam_marker and src_is_next_button_pressed() then
			show_selector_message = true
			Src_race_id = Src_race_id + 1
			if Src_race_id > num_races then
				Src_race_id = 1
			end
		end
		
		if show_selector_message then
			local race = src_get_race()
			
			src_message("Steelport Racing Club Mini\nMod by nclok1405\n\n{AUDIO_PLAYER_PREV_TRACK_IMG} or {AUDIO_PLAYER_NEXT_TRACK_IMG} to choose\n\nRACE NAME:\n"..race.name.."\n("..Src_race_id.."/"..num_races..")", 5, SYNC_ALL)
		end

		if Src_freeroam_trigger_hit then
			break
		end
	end

	Src_freeroam_trigger_hit = false
	src_clear_freeroam_marker()
	src_clear_freeroam_prompt()
	
	Src_players = player_names_get_all()	-- Get the list of active players
	Src_mission_name = ""	-- Ensure we're in Mini mode

	local race = src_get_race()
	if race.is_coordinate_viewer then
		return SRC_STATE_MINI_COORDINATE_VIEWER
	end

	return SRC_STATE_FIND_CAR
end

-- E key has been pushed
function src_freeroam_triggered()
	Src_freeroam_trigger_hit = true
end

-- Clear freeroam marker
function src_clear_freeroam_marker()
	if Src_freeroam_marker_active then
		marker_remove(SRC_FREEROAM_MARKER_MISSION[src_get_game()], SYNC_LOCAL)
		Src_freeroam_marker_active = false
	end
end

-- Clear freeroam prompt
function src_clear_freeroam_prompt()
	if Src_freeroam_prompt_active then
		hud_prompt_clear(LOCAL_PLAYER)
		Src_freeroam_prompt_active = false
	end
end

-- STATE: DX Freeroam
function src_state_dx_freeroam()
	src_message("Steelport Racing Club DX\nMod by nclok1405\n\n{AUDIO_PLAYER_PREV_TRACK_IMG} or {AUDIO_PLAYER_NEXT_TRACK_IMG} to choose", 5, LOCAL_PLAYER)
	hud_prompt(LOCAL_PLAYER, "CONTROL_START_GAME", "src_freeroam_triggered")

	if src_sriv() then
		hud_gsi_supress_popout(true)	-- Supress "new objective" anim
	end

	local num_races = #SRC_RACES
	local show_selector_message = true

	while true do
		thread_yield()
		
		-- Previous
		if src_is_prev_button_pressed() then
			show_selector_message = true
			Src_race_id = Src_race_id - 1
			if Src_race_id < 1 then
				Src_race_id = num_races
			end
		end
		-- Next
		if src_is_next_button_pressed() then
			show_selector_message = true
			Src_race_id = Src_race_id + 1
			if Src_race_id > num_races then
				Src_race_id = 1
			end
		end
		
		-- Z: AI ON/OFF
		if player_action_just_pressed("CBA_GAC_RECRUIT_DISMISS") and (not coop_is_active()) then
			Src_ai_enabled = not Src_ai_enabled
			if Src_ai_enabled then
				src_message("Fake Co-op Partner is now Enabled")
			else
				src_message("Fake Co-op Partner is now Disabled")
			end
		end
		
		if show_selector_message then
			local race = src_get_race()
			
			objective_text(0, "", race.name .. " (" .. Src_race_id .. "/" .. num_races .. ")", "", SYNC_ALL, -1)
			
			show_selector_message = false
		end

		if Src_freeroam_trigger_hit then
			break
		end
	end

	objective_text_clear(0)
	src_clear_message()

	if src_sriv() then
		hud_gsi_supress_popout(false)
	end

	Src_freeroam_trigger_hit = false
	src_clear_freeroam_prompt()

	Src_players = player_names_get_all()	-- Get the list of active players

	local race = src_get_race()
	if race.is_coordinate_viewer then
		return SRC_STATE_DX_COORDINATE_VIEWER
	end
	if race.is_replay then
		-- Vanilla Replay
		Src_vanilla_replay = true
		return SRC_STATE_EXIT
	end
	if race.is_exit then
		-- Exit
		mission_end_silently(false)
		return SRC_STATE_EXIT
	end

	return SRC_STATE_FIND_CAR
end

-- Next button pressed
function src_is_next_button_pressed()
	for i, action in pairs(SRC_NEXT_BUTTONS) do
		if player_action_just_pressed(action) then
			return true
		end
	end
	return false
end

-- Prev button pressed
function src_is_prev_button_pressed()
	for i, action in pairs(SRC_PREV_BUTTONS) do
		if player_action_just_pressed(action) then
			return true
		end
	end
	return false
end

-- STATE: Find Car
function src_state_find_car()
	-- Setup AI
	if (not coop_is_active()) and Src_ai_enabled then
		local group_human = SRC_AI_HUMAN_GROUP[src_get_game()]
		local group_vehicle = SRC_AI_VEHICLE_GROUP[src_get_game()]
		
		group_create_hidden(group_human, true)
		group_create_hidden(group_vehicle, true)
		
		local player = SRC_AI_HUMAN[src_get_game()]
		local myride = SRC_AI_VEHICLE[src_get_game()]
		
		-- Make the AI non-hostile, at least for now
		set_team(player, "Playas")
		inv_item_remove_all(player)
		ai_clear_priority_target(player)
		set_attack_player_flag(player, false)
		set_attack_enemies_flag(player, false)
		set_attack_peds_flag(player, false)
		on_death("src_ai_death_cb", player)
		character_show(player)
		
		vehicle_enter_teleport(player, myride)
		vehicle_suppress_npc_exit(myride, true)
		vehicle_never_flatten_tires(myride, true)
		vehicle_infinite_mass(myride, true)
		vehicle_set_crazy(myride, true)
		vehicle_set_team(myride, "Playas")
		on_vehicle_destroyed("src_ai_vehicle_destroyed_cb", myride)
		vehicle_show(myride)
		
		local x = SRC_EXIT_WARP[REMOTE_PLAYER].x
		local y = SRC_EXIT_WARP[REMOTE_PLAYER].y
		local z = SRC_EXIT_WARP[REMOTE_PLAYER].z
		src_teleport_vehicle(myride, x, y, z)

		marker_add(player, MINIMAP_ICON_SAINTS, OI_ASSET_COOP, OI_FLAGS_FULL, SYNC_ALL)

		Src_players = {LOCAL_PLAYER, player}
	end

	-- No Grenades
	src_allow_q_key_action(false)

	local hud_added = false
	local valid_count = -1
	while not src_is_all_players_in_valid_car() do
		thread_yield()
		
		if src_check_abort() then
			return SRC_STATE_FAIL
		end
		
		-- Get the number of players ready
		local num_players = #Src_players
		local new_valid_count = 0
		for idx, player in pairs(Src_players) do
			if src_is_player_in_valid_car(player) then
				new_valid_count = new_valid_count + 1
			end
		end
		
		if valid_count ~= new_valid_count then
			valid_count = new_valid_count
			
			if src_mini() then
				src_message("Enter a car\n" .. valid_count .. "/" .. num_players .. " players ready", 3)
			elseif src_dx() then
				if not hud_added then
					hud_x_of_y_add(1, SRC_MSG_TAGS[src_get_game()].objective_steal_a_car, valid_count, num_players, false, SYNC_ALL)
					hud_added = true
				else
					hud_x_of_y_update(1, valid_count)
				end
			end
		end
	end

	-- All players are now in a valid car
	if src_dx() then
		hud_x_of_y_remove(1)
	end

	-- Insert a small delay. This is to make crib garage vehicles to warp successfully.
	if src_srtt() then
		src_localized_objective("COOP_WAIT", 1)
		delay(1.8)
	end

	-- Fade Out
	mission_start_fade_out()

	for idx, player in pairs(Src_players) do
		if is_player_tag(player) then
			-- Disarm all players
			inv_item_equip_slot(WEAPON_SLOT_UNARMED, player)
			inv_weapon_disable_all_but_this_slot(WEAPON_SLOT_UNARMED, sync_from_player(player))
			-- Disallow vehicle exit
			set_player_can_enter_exit_vehicles(player, false)
		end

		-- Seatbelt Enable
		set_seatbelt_flag(player, true)

		local myride = get_char_vehicle_name(player)
		-- Make the vehicle unjackable
		set_unjackable_flag(myride, true)
		-- No flipping
		vehicle_suppress_flipping(myride, true)
		-- Disarm turret vehicles
		vehicle_set_weapons_disarmed(myride, true)
		-- Repair
		vehicle_repair(myride)
	end

	-- No homies
	party_set_recruitable(false)
	cell_spawns_enable(false)
	
	-- Ghost Town mode ON
	set_traffic_density(0)
	spawning_vehicles(false)
	set_ped_density(0)
	spawning_pedestrians(false)
	ambient_cop_spawn_enable(false)
	ambient_gang_spawn_enable(false)
	roadblocks_ambient_traffic_enable(false)
	roadblocks_enable(false)
	
	-- Keep notoriety to 0
	notoriety_set_min("police", 0)
	notoriety_set_max("police", 0)
	notoriety_set("police", 0)
	if src_srtt() then
		notoriety_set_min("morningstar", 0)
		notoriety_set_max("morningstar", 0)
		notoriety_set("morningstar", 0)
		notoriety_set_min("deckers", 0)
		notoriety_set_max("deckers", 0)
		notoriety_set("deckers", 0)
		notoriety_set_min("luchadores", 0)
		notoriety_set_max("luchadores", 0)
		notoriety_set("luchadores", 0)
	end

	-- Teleport to Spawn Grid
	local race = src_get_race()
	local radio_backup = {}
	for idx, player in pairs(Src_players) do
		local spawn_grid = race.spawn_grid[player]
		if spawn_grid == nil then
			spawn_grid = race.spawn_grid[REMOTE_PLAYER]
		end
		local x = spawn_grid.x
		local y = spawn_grid.y
		local z = spawn_grid.z
		
		local myride = get_char_vehicle_name(player)
		radio_backup[player] = radio_get_station(myride)
		
		if is_player_tag(player) then
			src_teleport_human(player, x, y, z)
		else
			src_teleport_vehicle(myride, x, y, z)
		end
	end

	if src_mini() then
		-- Spawn waypoint vehicles
		group_create_hidden("E3 Spawns", true)
		object_destroy("Script_Vehicle_Genki<001>")	-- DON'T REMOVE!!!
	elseif src_dx() then
		-- Spawn waypoint humans
		group_create_hidden(SRC_DX_WAYPOINT_GROUP[src_get_game()], true)
		for i, human in pairs(SRC_DX_WAYPOINT_HUMANS[src_get_game()]) do
			turn_invulnerable(human)
			set_team(human, "Playas")
			inv_item_remove_all(human)
			ai_clear_priority_target(human)
			set_attack_player_flag(human, false)
			set_attack_enemies_flag(human, false)
			set_ignore_ai_flag(human, true)
		end
	end

	src_clear_objective()

	mission_start_fade_in()
	-- Fade In

	-- Restore Radio
	for idx, player in pairs(Src_players) do
		local myride = get_char_vehicle_name(player)
		radio_set_station(myride, radio_backup[player])
	end

	if src_dx() then
		mission_set_checkpoint(race.name)
	end

	return SRC_STATE_GOTO_STARTING_GRID
end

-- This function checks if the player is controlling a valid car
function src_is_player_in_valid_car(player)
	-- Make sure the player is in a vehicle
	if not character_is_in_vehicle(player) then
		return false
	end
	-- Make sure the player is the vehicle's driver
	if not character_is_in_a_driver_seat(player) then
		return false
	end
	-- Make sure the player is driving a land vehicle
	if ((get_char_vehicle_type(player) ~= VT_AUTOMOBILE) and (get_char_vehicle_type(player) ~= VT_MOTORCYCLE)) then
		return false
	end
	return true
end

-- This function checks if all players are controlling a valid car
function src_is_all_players_in_valid_car()
	for idx, player in pairs(Src_players) do
		if not src_is_player_in_valid_car(player) then
			return false
		end
	end
	return true
end

-- AI
function src_ai_thread()
	local player = SRC_AI_HUMAN[src_get_game()]
	local myride = SRC_AI_VEHICLE[src_get_game()]

	src_message("AI Activated")
	
	while true do
		local target = src_get_waypoint_object(player)
		vehicle_set_script_hard_goto(myride, true)
		
		local exit_on_stop = false
		local allow_ram = true
		local allow_lateral_chase = false
		local no_sirens = true
		vehicle_chase(myride, target, exit_on_stop, allow_ram, allow_lateral_chase, no_sirens)
		
		thread_yield()
	end
	
	src_message("AI Deactivated")
end

-- STATE: Go to starting grid
function src_state_goto_starting_grid()
	local race = src_get_race()

	-- Guide players to the starting grid
	for idx, player in pairs(Src_players) do
		src_set_race_waypoint(player, 0)
	end

	--src_localized_objective("MSN_OBJ_PRE_PHONE_CALL", 5, SYNC_ALL, OI_ASSET_LOCATION)

	local hud_added = false
	local ready_count = -1
	while true do
		thread_yield()
		
		if src_check_abort(true) then
			return SRC_STATE_FAIL
		end

		local all_players_ready = true
		local new_ready_count = 0
		
		for idx, player in pairs(Src_players) do
			local starting_grid = race.starting_grid[player]
			if starting_grid == nil then
				starting_grid = race.starting_grid[REMOTE_PLAYER]
			end
			local x = starting_grid.x
			local y = starting_grid.y
			local z = starting_grid.z
			local dist = starting_grid.dist
			
			if not is_player_tag(player) then
				dist = dist + 20	-- Cheat for AI. The AI never try to ram the target :(
				
				-- Make this AI hostile
				set_attack_player_flag(player, true)
				set_attack_enemies_flag(player, true)
				set_attack_peds_flag(player, true)
				set_team(player, "deckers")
				
				-- Spawn AI thread
				if Src_ai_thread_handle == -1 then
					Src_ai_thread_handle = thread_new("src_ai_thread")
				end
			end
			
			if not src_is_close_enough(player, x, y, z, dist) then
				all_players_ready = false
			else
				new_ready_count = new_ready_count + 1
			end
		end
		
		if ready_count ~= new_ready_count then
			ready_count = new_ready_count
			
			if src_mini() then
				src_message("Go to the starting grid\n" .. ready_count .. "/" .. #Src_players .. " players ready", 3)
			elseif src_dx() then
				if not hud_added then
					hud_x_of_y_add(1, "MSN_OBJ_PRE_PHONE_CALL", ready_count, #Src_players, false, SYNC_ALL)
				else
					hud_x_of_y_update(1, ready_count)
				end
			end
		end
		
		if all_players_ready then
			break
		end
	end

	if src_dx() then
		hud_x_of_y_remove(1)
	end
	src_clear_objective()

	-- Disable player controls
	local max_speed = {}
	for idx, player in pairs(Src_players) do
		src_set_race_waypoint(player, 1)
		vehicle_freeze(player, true)
		
		max_speed[player] = vehicle_get_max_speed(get_char_vehicle_name(player))
		vehicle_max_speed(get_char_vehicle_name(player), 0)
		
		if is_player_tag(player) then
			player_movement_disable(player)
			player_actions_disable(player)
		end
	end

	-- Start Countdown
	if src_sriv() then
		countdown_start(0)
		while countdown_is_complete() == false do
			thread_yield()
		end
	else
		hud_critical_timer_set(1000*3, SRC_MSG_TAGS[src_get_game()].race_start_countdown, "")

		audio_object_post_event("UI_WHR_CNT_ANIM_IN", nil, nil, LOCAL_PLAYER)
		delay(1)
		audio_object_post_event("UI_WHR_CNT_TWO", nil, nil, LOCAL_PLAYER)
		delay(1)
		audio_object_post_event("UI_WHR_CNT_ONE", nil, nil, LOCAL_PLAYER)
		delay(1)
		
		hud_critical_timer_stop()
		audio_object_post_event("UI_HUD_GENERIC_DIV_START", nil, nil, LOCAL_PLAYER)
	end

	-- Restore player controls
	for idx, player in pairs(Src_players) do
		vehicle_freeze(player, false)

		-- Restore Speed
		vehicle_max_speed(get_char_vehicle_name(player), max_speed[player])

		if is_player_tag(player) then
			player_movement_enable(player)
			player_actions_enable(player)
		end
	end
	
	-- Apply world settings
	spawning_vehicles( (race.traffic_density > 0) )
	set_traffic_density(race.traffic_density)
	spawning_pedestrians( (race.pedestrian_density > 0) )
	set_ped_density(race.pedestrian_density)

	roadblocks_ambient_traffic_enable(race.roadblocks)
	roadblocks_enable(race.roadblocks)

	notoriety_set_min("police", race.police_notoriety_min)
	notoriety_set_max("police", race.police_notoriety_max)
	ambient_cop_spawn_enable( (race.police_notoriety_min > 0) )

	Src_warp_on_exit = race.warp_on_exit

	return SRC_STATE_RACE
end

-- STATE: Race
function src_state_race()
	local race = src_get_race()
	local checkpoints = race.checkpoints
	local num_cp = #checkpoints

	local cp_numbers = {}	-- Current checkpoint for each player
	local timer = {}	-- Timer for each player
	local medal = {}	-- Current Medal for each player
	local time_since_last_checkpoint = {}	-- Time elapsed since the last checkpoint

	-- Init variables
	for idx, player in pairs(Src_players) do
		cp_numbers[player] = 1
		timer[player] = 0
		time_since_last_checkpoint[player] = 0
	end
	
	-- Medal Text
	local medal_strings = {
		SRC_MSG_TAGS[src_get_game()].medal_gold,
		SRC_MSG_TAGS[src_get_game()].medal_silver,
		SRC_MSG_TAGS[src_get_game()].medal_bronze,
		"DIVERSION_STREAKING_RAN_OUT_OF_TIME_TEXT",
	}

	-- Medal Time Limit
	local gold = race.time[1]
	local silver = gold + race.time[2]
	local bronze = silver + race.time[3]
	
	local winner = ""	-- Winner (LOCAL_PLAYER or REMOTE_PLAYER)
	local race_run = true	-- true during the race

	while race_run do
		thread_yield()
		
		-- Check for abort
		if src_check_abort(true) then
			return SRC_STATE_FAIL
		end
		
		for idx, player in pairs(Src_players) do
			local myride = get_char_vehicle_name(player)
			local speed = get_vehicle_speed(myride)
			local cp_number = cp_numbers[player]
			local current_cp = checkpoints[cp_number]
			local x = current_cp.x
			local y = current_cp.y
			local z = current_cp.z
			local dist = current_cp.dist
			if not is_player_tag(player) then
				dist = dist + 20	-- Cheat for AI. The AI never try to ram the target :(
			end

			-- Run the timers
			timer[player] = timer[player] + get_frame_time()
			time_since_last_checkpoint[player] = time_since_last_checkpoint[player] + get_frame_time()
			
			-- Check the current medal and remaining time
			local new_medal = SRC_MEDAL_GOLD
			local max_time = gold
			local remaining_time = gold - timer[player]
			if remaining_time < 0 then
				new_medal = SRC_MEDAL_SILVER
				max_time = silver
				remaining_time = silver - timer[player]
			end
			if remaining_time < 0 then
				new_medal = SRC_MEDAL_BRONZE
				max_time = bronze
				remaining_time = bronze - timer[player]
			end
			if remaining_time < 0 then
				new_medal = SRC_MEDAL_FAIL
				max_time = bronze
				remaining_time = 0
			end

			if medal[player] ~= new_medal then
				-- Medal has changed (including start)
				
				-- Expire messages
				if (new_medal == SRC_MEDAL_SILVER) and (medal[player] == SRC_MEDAL_GOLD) then
					src_message("[format][color:gold]Gold Time Expired[/format]", 4, player)
				elseif (new_medal == SRC_MEDAL_BRONZE) and (medal[player] == SRC_MEDAL_SILVER) then
					src_message("[format][color:silver]Silver Time Expired[/format]", 4, player)
				elseif (new_medal == SRC_MEDAL_FAIL) and (medal[player] == SRC_MEDAL_BRONZE) then
					src_message("[format][color:bronze]Bronze Time Expired[/format]", 4, player)
				end
				
				medal[player] = new_medal
				
				if is_player_tag(player) then
					if src_mini() then
						-- Remove the existing Combo HUD and create a new one
						src_remove_combo(player)
						
						local hud_type = 3	-- HPT_TIME
						local priority = 4	-- HUD_MESSAGE_PRIORITY_SUPER_CRITICAL
						local symbol = 0	-- HPS_NONE
						local skin = 0	-- HP_SKIN_DEFAULT
						local combo_meter = 0
						Src_combo_handles[player] = hud_player_combo_add(0, 0, medal_strings[new_medal], remaining_time, true, hud_type, priority, symbol, skin, sync_from_player(player), false, combo_meter, false)
					elseif src_dx() then
						-- (Re)add HUD
						
						-- Each player gets their own x_of_y HUD
						hud_x_of_y_remove(SRC_HUD_PLAYER_INDEX[player])
						hud_x_of_y_add(SRC_HUD_PLAYER_INDEX[player], medal_strings[new_medal], cp_number - 1, num_cp, false, sync_from_player(player))
						
						-- GSI Timer is shared between players so only LOCAL_PLAYER should handle it
						if player == LOCAL_PLAYER then
							hud_timer_stop(0)
							if remaining_time > 0 then
								hud_timer_set(0, remaining_time * 1000, "", SYNC_ALL)
							end
						end
					end
				end
			else
				-- Medal unchanged
				if src_mini() then
					-- Update the current Combo HUD to show remaining time
					hud_player_combo_update_value(Src_combo_handles[player], remaining_time, 0, false, 0, sync_from_player(player))
				end
			end

			-- Speedometer (DX only)
			if src_dx() and is_player_tag(player) then
				local meter_flashing = true
				local max_speed = 100 --vehicle_get_max_speed(myride)
				local combo_meter = speed / max_speed
				if combo_meter < 0 then
					combo_meter = 0
				elseif combo_meter > 1 then
					combo_meter = 1
				end
				
				if Src_combo_handles[player] ~= nil and Src_combo_handles[player] ~= -1 then
					Src_combo_handles[player] = hud_player_combo_update_value(Src_combo_handles[player], speed, combo_meter, combo_meter, meter_flashing, sync_from_player(player))
				else
					local hud_type = 0	-- HPT_NONE
					local priority = 3	-- HUD_MESSAGE_PRIORITY_CRITICAL
					local symbol = 0	-- HPS_NONE
					local skin = 0	-- HP_SKIN_DEFAULT
					
					Src_combo_handles[player] = hud_player_combo_add(0, 0, "CYBERSPACE", speed, true, hud_type, priority, symbol, skin, sync_from_player(player), true, combo_meter, true, meter_flashing)
				end
			end

			-- AI Cheat!
			if (not is_player_tag(player)) then
				local cheat = false
				
				-- Behind 2 checkpoints
				if (cp_number < cp_numbers[LOCAL_PLAYER] - 1) and (time_since_last_checkpoint[player] >= 5) then
					cheat = true
				end
				-- Stuck?
				if (cp_number < cp_numbers[LOCAL_PLAYER]) and (time_since_last_checkpoint[player] >= 10) and (time_since_last_checkpoint[LOCAL_PLAYER] >= 5) and (speed < 10) then
					cheat = true
				end
				
				if cheat then
					src_teleport_vehicle(myride, x, y, z)	-- Let him cheat
				end
			end
			
			-- Checkpoint
			if src_is_player_in_valid_car(player) and src_is_close_enough(player, x, y, z, dist) then
				time_since_last_checkpoint[player] = 0
				src_remove_race_waypoint(player)

				if cp_number < num_cp then
					cp_numbers[player] = cp_numbers[player] + 1
					cp_number = cp_numbers[player]
					
					if src_mini() then
						src_message("CHECKPOINTS\n"..(cp_number - 1).."/"..num_cp, 3, player)
					elseif src_dx() and is_player_tag(player) then
						hud_x_of_y_update(SRC_HUD_PLAYER_INDEX[player], cp_number - 1)
					end
					
					if new_medal == SRC_MEDAL_GOLD then
						audio_play_persona_line(player, SRC_AUDIO_CHECKPOINT_PASSED[src_get_game()])
					end
					
					audio_object_post_event("WEAPON_PURCHASE", nil, nil, player)
					
					src_set_race_waypoint(player, cp_numbers[player])
				else
					winner = player
					race_run = false
					break
				end
			end
		end
	end

	-- Race Finished
	if src_dx() then
		hud_timer_stop(0)
	end

	-- Stop AI thread
	if Src_ai_thread_handle ~= -1 then
		thread_kill(Src_ai_thread_handle)
		Src_ai_thread_handle = -1
	end

	local final_medal = medal[winner]
	if final_medal == SRC_MEDAL_FAIL then
		audio_object_post_event(SRC_AUDIO_FAIL[src_get_game()], nil, nil, winner)
	elseif final_medal == SRC_MEDAL_GOLD then
		audio_object_post_event(SRC_AUDIO_GOLD[src_get_game()], nil, nil, winner)
	elseif final_medal == SRC_MEDAL_SILVER then
		audio_object_post_event(SRC_AUDIO_SILVER[src_get_game()], nil, nil, winner)
	elseif final_medal == SRC_MEDAL_BRONZE then
		audio_object_post_event(SRC_AUDIO_BRONZE[src_get_game()], nil, nil, winner)
	end

	for idx, player in pairs(Src_players) do
		src_remove_race_waypoint(player)
		src_remove_combo(player)

		if src_dx() then
			hud_x_of_y_remove(SRC_HUD_PLAYER_INDEX[player])
		end

		if is_player_tag(player) then
			local hud_type = 3	-- HPT_TIME
			local priority = 4	-- HUD_MESSAGE_PRIORITY_SUPER_CRITICAL
			local symbol = 0	-- HPS_NONE
			local skin = 0	-- HP_SKIN_DEFAULT
			local combo_meter = 0
			Src_combo_handles[player] = hud_player_combo_add(0, 0, medal_strings[final_medal], timer[player], true, hud_type, priority, symbol, skin, sync_from_player(player), false, combo_meter, false)
			
			if final_medal == SRC_MEDAL_GOLD and winner == player then
				src_message("You received a [format][color:gold]gold medal![/format] You rock!\nReward: $1,000", 5, player)
				cash_add(1000, player)
			elseif final_medal == SRC_MEDAL_GOLD and winner ~= player then
				src_message("Your partner received a [format][color:gold]gold medal![/format]\nReward: $500", 5, player)
				cash_add(500, player)
			elseif final_medal == SRC_MEDAL_SILVER and winner == player then
				src_message("You received a [format][color:silver]silver medal![/format] Good job!\nReward: $250", 5, player)
				cash_add(250, player)
			elseif final_medal == SRC_MEDAL_SILVER and winner ~= player then
				src_message("Your partner received a [format][color:silver]silver medal![/format]\nReward: $125", 5, player)
				cash_add(125, player)
			elseif final_medal == SRC_MEDAL_BRONZE and winner == player then
				src_message("You received a [format][color:bronze]bronze medal.[/format] Not bad!\nReward: $50", 5, player)
				cash_add(50, player)
			elseif final_medal == SRC_MEDAL_BRONZE and winner ~= player then
				src_message("Your partner received a [format][color:bronze]bronze medal.[/format]\nReward: $25", 5, player)
				cash_add(25, player)
			else
				src_message("No medal earned. Better luck next time.", 5, player)
			end
		end
	end

	if final_medal == SRC_MEDAL_FAIL then
		return SRC_STATE_OUT_OF_TIME
	else
		return SRC_STATE_WIN
	end
end

-- Get waypoint vehicle or human
function src_get_waypoint_object(player)
	if src_mini() then
		return SRC_MINI_WAYPOINT_VEHICLES[player]
	else
		if SRC_DX_WAYPOINT_HUMANS[src_get_game()][player] == nil then
			return SRC_DX_WAYPOINT_HUMANS[src_get_game()][REMOTE_PLAYER]
		end
		return SRC_DX_WAYPOINT_HUMANS[src_get_game()][player]
	end
end

-- Remove race waypoint
function src_remove_race_waypoint(player)
	local waypoint_object = src_get_waypoint_object(player)
	minimap_icon_remove_radius(waypoint_object, sync_from_player(player))
	marker_remove(waypoint_object, sync_from_player(player))
	
	if is_player_tag(player) then
		waypoint_remove(sync_from_player(player))
	end
end

-- Set race waypoint
-- If cp_number == 0, set waypoint to the starting grid
function src_set_race_waypoint(player, cp_number)
	if cp_number == nil then
		cp_number = 0
	end
	src_remove_race_waypoint(player)

	local race = src_get_race()
	local checkpoints = race.checkpoints
	
	local x, y, z, dist
	
	if cp_number == 0 then
		local starting_grid = race.starting_grid[player]
		if starting_grid == nil then
			starting_grid = race.starting_grid[REMOTE_PLAYER]
		end
		x = starting_grid.x
		y = starting_grid.y
		z = starting_grid.z
		dist = starting_grid.dist
	else
		local current_cp = checkpoints[cp_number]
		x = current_cp.x
		y = current_cp.y
		z = current_cp.z
		dist = current_cp.dist
	end
	
	local waypoint_object = src_get_waypoint_object(player)

	if src_mini() then
		src_teleport_vehicle(waypoint_object, x, y, z)
	else
		src_teleport_human(waypoint_object, x, y, z)
	end

	if is_player_tag(player) then
		waypoint_add(waypoint_object, sync_from_player(player))
		minimap_icon_add_radius(waypoint_object, dist, sync_from_player(player))

		local minimap_icon = MINIMAP_ICON_LOCATION
		local oi_asset = OI_ASSET_LOCATION
		if cp_number == #checkpoints then
			-- Make final checkpoint green, like in SR2
			minimap_icon = MINIMAP_ICON_PROTECT_ACQUIRE
			oi_asset = OI_ASSET_DEFEND
		end
		marker_add(waypoint_object, minimap_icon, oi_asset, OI_FLAGS_FULL, sync_from_player(player))
	end
end

function src_remove_combo(player)
	if Src_combo_handles[player] ~= nil and Src_combo_handles[player] ~= -1 then
		hud_player_combo_remove(Src_combo_handles[player], sync_from_player(player))
	end
	Src_combo_handles[player] = -1
end

-- Post-race Cleanup
function src_cleanup()
	party_set_recruitable(true)
	cell_spawns_enable(true)
	src_allow_q_key_action(true)

	for idx, player in pairs(Src_players) do
		src_remove_race_waypoint(player)
		
		if is_player_tag(player) then
			inv_weapon_disable_all_slots(false, sync_from_player(player))
			player_movement_enable(player)
			player_actions_enable(player)
			set_player_can_enter_exit_vehicles(player, true)
		end

		set_seatbelt_flag(player, false)

		if character_is_in_vehicle(player) then
			local myride = get_char_vehicle_name(player)
			set_unjackable_flag(myride, false)
			vehicle_suppress_flipping(myride, false)
			vehicle_set_weapons_disarmed(myride, false)
			vehicle_repair(myride)
		end
		
		src_remove_combo(player)
	end

	waypoint_remove(SYNC_ALL)

	-- Ghost Town mode OFF
	set_traffic_density(1)
	spawning_vehicles(true)
	set_ped_density(1)
	spawning_pedestrians(true)
	ambient_cop_spawn_enable(true)
	ambient_gang_spawn_enable(true)
	roadblocks_ambient_traffic_enable(true)
	roadblocks_enable(true)

	-- Reset notoriety
	notoriety_set_min("police", 0)
	notoriety_set_max("police", MAX_NOTORIETY_LEVEL)
	if src_srtt() then
		notoriety_set_min("morningstar", 0)
		notoriety_set_max("morningstar", MAX_NOTORIETY_LEVEL)
		notoriety_set_min("deckers", 0)
		notoriety_set_max("deckers", MAX_NOTORIETY_LEVEL)
		notoriety_set_min("luchadores", 0)
		notoriety_set_max("luchadores", MAX_NOTORIETY_LEVEL)
	end

	hud_critical_timer_stop()

	if Src_ai_thread_handle ~= -1 then
		thread_kill(Src_ai_thread_handle)
		Src_ai_thread_handle = -1
	end
	
	-- Unload groups
	if src_mini() then
		group_destroy("E3 Spawns")
	elseif src_dx() then
		group_destroy(SRC_DX_WAYPOINT_GROUP[src_get_game()])
	end

	if src_dx() then
		objective_text_clear(0)
		hud_timer_stop(0)
		hud_x_of_y_remove(1)
		hud_x_of_y_remove(2)

		if src_sriv() then
			hud_gsi_supress_popout(false)
		end
		
		if (not coop_is_active()) and Src_ai_enabled then
			local player = SRC_AI_HUMAN[src_get_game()]
			local myride = SRC_AI_VEHICLE[src_get_game()]
			
			marker_remove(player, SYNC_ALL)
			on_vehicle_destroyed("", myride)
			on_death("", player)
			
			local group_human = SRC_AI_HUMAN_GROUP[src_get_game()]
			local group_vehicle = SRC_AI_VEHICLE_GROUP[src_get_game()]
			group_destroy(group_human)
			group_destroy(group_vehicle)
		end
	end
end

-- AI vehicle died
function src_ai_vehicle_destroyed_cb(myride)
	local player = SRC_AI_HUMAN[src_get_game()]
	character_kill(player, true)
	on_vehicle_destroyed("", myride)
end

-- AI died
function src_ai_death_cb(victim, attacker)
	marker_remove(victim, SYNC_ALL)
	on_death("", victim)
end

-- Returns true if the game is SRTT
function src_srtt()
	if MAX_NOTORIETY_LEVEL == 5 then
		return true
	end
	return false
end

-- Returns true if the game is SRIV
function src_sriv()
	if MAX_NOTORIETY_LEVEL == 6 then
		return true
	end
	return false
end

-- Get current game (SRC_SRTT or SRC_SRIV)
function src_get_game()
	if MAX_NOTORIETY_LEVEL == 5 then
		return SRC_SRTT
	end
	return SRC_SRIV
end

-- Teleport a human to the specified location
function src_teleport_human(human, x, y, z)
	-- Used for custom teleports
	local stele_Posx = 431.295288085938
	local stele_Posy = 8.0703125
	local stele_Posz = 936.460083007812
	local obj_name = "Dock_Purchase"
	
	if src_sriv() then
		-- Teleport for SRIV
		stele_Posx = 1361.86633300781
		stele_Posy = 33.0730209350586
		stele_Posz = -818.10595703125
		obj_name = "nw_qm_nav"
	end

	teleport_to_object(human, obj_name, false, false, x - stele_Posx, y - stele_Posy, z - stele_Posz, false)
end

-- Teleport a vehicle to the specified location
function src_teleport_vehicle(vehicle_name, x, y, z)
	-- Used for custom teleports
	local stele_Posx = -807.969360351562
	local stele_Posy = 18.0140247344971
	local stele_Posz = -1258.45178222656
	local obj_name = "chop04_target5_spawn_npc 001"	-- Must be a navpoint

	if src_sriv() then
		-- Teleport for SRIV
		stele_Posx = 1361.86633300781
		stele_Posy = 33.0730209350586
		stele_Posz = -818.10595703125
		obj_name = "nw_qm_nav"
	end

	-- HACK: Add Y offset to move the marker down
	if SRC_MINI_WAYPOINT_Y_OFFSET[vehicle_name] ~= nil then
		y = y + SRC_MINI_WAYPOINT_Y_OFFSET[vehicle_name]
	end

	local on_ground = false
	teleport_vehicle_to_object(vehicle_name, obj_name, x - stele_Posx, y - stele_Posy, z - stele_Posz, 0, on_ground, false)
end

-- Check if the specified object is close enough to the specified location
function src_is_close_enough(obj, x, y, z, dist)
	local px, py, pz = get_object_pos(obj)
	local dx = px - x
	local dy = py - y
	local dz = pz - z
	if dx < 0 then
		dx = -dx
	end
	if dy < 0 then
		dy = -dy
	end
	if dz < 0 then
		dz = -dz
	end
	if (dx < dist) and (dy < dist) and (dz < dist) then
		return true
	end
	return false
end

-- Clear the last message
function src_clear_message(sync)
	if sync == nil then
		sync = SYNC_ALL
	end
	if Src_last_message_handle[sync] ~= nil and Src_last_message_handle[sync] ~= -1 then
		message_remove(Src_last_message_handle[sync], false)
		Src_last_message_handle[sync] = -1
	end
end

-- Show a message
-- msg: Message to display
-- duration: Number of seconds before this message disappears (default is 5 seconds)
-- player: Player to display this message (accepts both *_PLAYER and SYNC_* constants)
function src_message(msg, duration, player, localize)
	if duration == nil then
		duration = 5
	end
	if localize == nil then
		localize = false
	end

	local sync = SYNC_ALL
	if (player == LOCAL_PLAYER) or (player == SYNC_LOCAL) then
		sync = SYNC_LOCAL
	end
	if (player == REMOTE_PLAYER) or (player == SYNC_REMOTE) then
		sync = SYNC_REMOTE
	end

	src_clear_message(sync)

	Src_last_message_handle[sync] = message(msg, duration, localize, sync)
end

-- Show a localized message
function src_localized_message(msg, duration, player)
	src_message(msg, duration, player, true)
end

-- true on Mini
function src_mini()
	return Src_mission_name == ""
end

-- true on DX
function src_dx()
	return Src_mission_name ~= ""
end

-- Enable or disable player's Q key action (Grenades or Super Powers)
function src_allow_q_key_action(enable)
	if src_srtt() then
		if enable then
			player_grenades_enable()
		else
			player_grenades_disable()
		end
	elseif src_sriv() then
		player_super_attacks_enable(enable)
	end
end

-- State: Win
function src_state_win()
	delay(9)
	
	if src_mini() then
		src_cleanup()
		src_postrace_warp()
		return SRC_STATE_MINI_FREEROAM
	else
		mission_end_success(Src_mission_name)
		return SRC_STATE_EXIT
	end
end

-- State: Out of Time
function src_state_out_of_time()
	delay(9)

	if src_mini() then
		src_cleanup()
		src_postrace_warp()
		return SRC_STATE_MINI_FREEROAM
	else
		mission_end_failure(Src_mission_name, "DIVERSION_STREAKING_RAN_OUT_OF_TIME_TEXT")
		return SRC_STATE_EXIT
	end
end

-- State: Fail
function src_state_fail()
	src_localized_message(Src_fail_reason)
	audio_object_post_event(SRC_AUDIO_FAIL[src_get_game()], nil, nil, LOCAL_PLAYER)

	if src_mini() then
		src_cleanup()
		src_postrace_warp()
		return SRC_STATE_MINI_FREEROAM
	else
		delay(3)
		mission_end_failure(Src_mission_name, Src_fail_reason)
		return SRC_STATE_EXIT
	end
end

-- Show a localized objective message
-- Displayed as a normal message in Mini
-- Displayed on GSI in DX
function src_localized_objective(msg, duration, sync, icon)
	if src_mini() then
		src_localized_message(msg, duration, sync)
	else
		if icon == nil then
			icon = -1
		end
		objective_text(0, msg, "", "", sync, icon)
	end
end

-- Clear currently displayed objective
function src_clear_objective()
	if src_mini() then
		src_clear_message()
	else
		objective_text_clear(0)
	end
end

-- State: Mini Coordinate Viewer
function src_state_mini_coordinate_viewer()
	-- Ghost Town mode ON
	set_traffic_density(0)
	spawning_vehicles(false)
	set_ped_density(0)
	spawning_pedestrians(false)
	ambient_cop_spawn_enable(false)
	ambient_gang_spawn_enable(false)
	roadblocks_ambient_traffic_enable(false)
	roadblocks_enable(false)
	
	-- Keep notoriety to 0
	notoriety_set_min("police", 0)
	notoriety_set_max("police", 0)
	notoriety_set("police", 0)
	if src_srtt() then
		notoriety_set_min("morningstar", 0)
		notoriety_set_max("morningstar", 0)
		notoriety_set("morningstar", 0)
		notoriety_set_min("deckers", 0)
		notoriety_set_max("deckers", 0)
		notoriety_set("deckers", 0)
		notoriety_set_min("luchadores", 0)
		notoriety_set_max("luchadores", 0)
		notoriety_set("luchadores", 0)
	end

	src_message("Push {RECRUIT_DISMISS_IMG} to view coordinates\nPush {ATTACK_SECONDARY_IMG} twice to quit", 4)

	local run = true
	while run do
		thread_yield()

		if player_action_just_pressed("CBA_GAC_RECRUIT_DISMISS") then
			local x, y, z = get_object_pos(LOCAL_PLAYER)
			src_message("X:"..x.."\nY:"..y.."\nZ:"..z, 10)
		end
		
		Src_abort_timer = Src_abort_timer - get_frame_time()
		if Src_abort_timer < 0 then
			Src_abort_timer = 0
		end
		if player_action_just_pressed("CBA_OFC_ATTACK_SECONDARY") then
			if Src_abort_timer > 0 then
				run = false
			else
				Src_abort_timer = 2
				src_message("Push {ATTACK_SECONDARY_IMG} again to quit", 2, LOCAL_PLAYER)
			end
		end
	end
	src_clear_message()

	src_cleanup()
	return SRC_STATE_MINI_FREEROAM
end

function src_state_dx_coordinate_viewer()
	-- Ghost Town mode ON
	set_traffic_density(0)
	spawning_vehicles(false)
	set_ped_density(0)
	spawning_pedestrians(false)
	ambient_cop_spawn_enable(false)
	ambient_gang_spawn_enable(false)
	roadblocks_ambient_traffic_enable(false)
	roadblocks_enable(false)
	
	-- Keep notoriety to 0
	notoriety_set_min("police", 0)
	notoriety_set_max("police", 0)
	notoriety_set("police", 0)
	if src_srtt() then
		notoriety_set_min("morningstar", 0)
		notoriety_set_max("morningstar", 0)
		notoriety_set("morningstar", 0)
		notoriety_set_min("deckers", 0)
		notoriety_set_max("deckers", 0)
		notoriety_set("deckers", 0)
		notoriety_set_min("luchadores", 0)
		notoriety_set_max("luchadores", 0)
		notoriety_set("luchadores", 0)
	end

	if src_sriv() then
		hud_gsi_supress_popout(true)	-- Supress "new objective" anim
	end
	
	while true do
		thread_yield()

		local x, y, z = get_object_pos(LOCAL_PLAYER)
		objective_text(0, "", "X:"..x..", Y:"..y..", Z:"..z, "", SYNC_ALL, -1)
	end
	
	return SRC_STATE_EXIT
end
